<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <!-- <el-form-item label="入库单id" prop="stockInId">
        <el-input v-model="formData.stockInId" placeholder="请输入入库单id" />
      </el-form-item> -->
      <el-form-item label="入库单编号" prop="stockInNo">
        <el-input v-model="formData.stockInNo" placeholder="请输入入库单编号" />
      </el-form-item>
      <el-form-item label="入库单项id" prop="stockInItemId">
        <el-input v-model="formData.stockInItemId" placeholder="请输入入库单项id" />
      </el-form-item>
      <!-- <el-form-item label="计划id" prop="planId">
        <el-input v-model="formData.planId" placeholder="请输入计划id" />
      </el-form-item> -->
      <el-form-item label="产品" prop="productId">
        <el-input v-model="formData.productId" placeholder="请输入产品" />
      </el-form-item>
      <el-form-item label="数量" prop="number">
        <el-input v-model="formData.number" placeholder="请输入数量" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { StockInDetailApi, StockInDetailVO } from '@/api/mes/stockindetail'

/** 生产入库分配明细 表单 */
defineOptions({ name: 'StockInDetailForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  stockInId: undefined,
  stockInNo: undefined,
  stockInItemId: undefined,
  planId: undefined,
  productId: undefined,
  number: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await StockInDetailApi.getStockInDetail(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as StockInDetailVO
    if (formType.value === 'create') {
      await StockInDetailApi.createStockInDetail(data)
      message.success(t('common.createSuccess'))
    } else {
      await StockInDetailApi.updateStockInDetail(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    stockInId: undefined,
    stockInNo: undefined,
    stockInItemId: undefined,
    planId: undefined,
    productId: undefined,
    number: undefined
  }
  formRef.value?.resetFields()
}
</script>